////////////////////////////////////////////////////////////////////////
// vlc.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.vlc")

// <%pre>
#line 1 "vlc.ecpp"


#include <setup.h>
#include <tools.h>
#include <users.h>

using namespace std;
using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class controls_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        controls_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    controls_type controls;
};

static tnt::ComponentFactoryImpl<_component_> Factory("vlc");

static const char* rawData = "\214\000\000\000\260\000\000\000\273\000\000\000\274\000\000\000\276\000\000\000\277\000"
  "\000\000\016\001\000\000\241\001\000\000\247\001\000\000M\002\000\000R\002\000\000\220\002\000\000\225\002\000\000"
  "\376\002\000\000\000\003\000\000\003\003\000\000\033\003\000\000\337\003\000\000\347\003\000\000\350\003\000\000\361"
  "\003\000\000\002\004\000\000\003\004\000\000\004\004\000\000P\004\000\000\215\004\000\000\313\004\000\000\325\004\000"
  "\000\006\005\000\000\020\005\000\000\033\005\000\0009\005\000\000;\005\000\000Z\005\000\000[\005\000\000\n<html>\n\t<"
  "head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t\t<script type=\"text/javascript\" src=\"js/mootools/mootools.v1"
  ".11.js\"></script>\n\t\t<script type=\"text/javascript\" src=\"js/live/vlc.js\"></script>\n\t\t<script type=\"text/ja"
  "vascript\"><!--\n\t\t\tvar vlcControl = new VLC(\"video1\", {\n\t\t\t\t\t\n\t\t\t\t\t\n\t\t\t\t\t\toffset: 5\n\t\t\t"
  "\t});\n\t\t\tvlcControl.addEvent('toggle', function(id, state){\n\t\t\t\t\tvar text = null;\n\t\t\t\t\tswitch (id) {"
  "\n\t\t\t\t\tcase \"TogglePlay\":\n\t\t\t\t\t\ttext = state \? \"\" : \"\";\n\t\t\t\t\t\tbreak;\n\t\t\t\t\tcase \"Togg"
  "leMute\":\n\t\t\t\t\t\ttext = state \? \"\" : \"\";\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\tif (text)\n\t\t\t\t\t"
  "\t$(id).setHTML(text);\n\t\t\t\t});\n\t\t--></script>\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n"
  "\t\t\t<embed type=\"application/x-vlc-plugin\" pluginspage=\"http://www.videolan.org/\" version=\"VideoLAN.VLCPlugin."
  "2\" id=\"video1\" name=\"video1\" autoplay=\"yes\" loop=\"no\" width=\"720\" height=\"576\" target=\"\" />\n\t\t\t\n"
  "\t\t</div>\n\t</body>\n</html>\n\n\n<div id=\"vlcControls\">\n\t<button id=\"TogglePlay\" type=\"button\" class=\"gre"
  "en\"></button>\n\t<button id=\"ToggleMute\" type=\"button\" class=\"red\"></button>\n\t<button id=\"FullScreen\" type"
  "=\"button\" class=\"blue\"></button>\n\t<button id=\"Close\" type=\"button\" class=\"yellow\"></button>\n<!-- --><p>:"
  " <span class=\"bold\"><a href=\"\"></a></span></p><!-- -->\n</div>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    controls(*this, "controls")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("vlc " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
tChannelID channel = tnt::stringTo<tChannelID>("channel", "tChannelID", qparam.param("channel"), reply.out().getloc());
string async = tnt::stringTo<string>("async", "string", qparam.param("async"), reply.out().getloc());
string recid = tnt::stringTo<string>("recid", "string", qparam.param("recid"), reply.out().getloc());
  // </%args>

#line 17 "vlc.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 20 "vlc.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 23 "vlc.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	if (!cUser::CurrentUserHasRightTo(UR_STARTREPLAY))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

	bool asyncReq = !async.empty() && (lexical_cast<int>(async) != 0);

    // the availabilty of Channel signals that we will do live tv streaming.
	Channel = 0;
	if (recid.empty()) {
		pageTitle = tr("VLC: live video stream");
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
		Channel = (cChannel *)Channels->GetByChannelID(channel);
#else
		ReadLock channelsLock(Channels);

		if (!channelsLock) {
			throw HtmlError(tr("Couldn't aquire access to channels, please try again later."));
		}
		Channel = Channels.GetByChannelID(channel);
#endif
		if (Channel == 0) {
			throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );
		}
	}
	else {
		pageTitle = tr("VLC: play recording");
	}

  // <& pageelems.doc_type ...
  { 
#line 53 "vlc.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 53 "vlc.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 56 "vlc.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 57 "vlc.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 57 "vlc.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n
#line 58 "vlc.ecpp"

	if (!asyncReq) {

  reply.out() << data[3]; // \t\t
  // <& pageelems.ajax_js ...
  { 
#line 61 "vlc.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 61 "vlc.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[4]; // \n
#line 62 "vlc.ecpp"

	}
	else {

  reply.out() << data[5]; // \t\t<script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n
#line 67 "vlc.ecpp"

	}

  reply.out() << data[6]; // \t\t<script type="text/javascript" src="js/live/vlc.js"></script>\n\t\t<script type="text/javascript"><!--\n\t\t\tvar vlcControl = new VLC("video1", {\n\t\t\t\t\t
#line 73 "vlc.ecpp"
  if ( !asyncReq )
    reply.sout() <<  "autoresize: false," ;
  reply.out() << data[7]; // \n\t\t\t\t\t
#line 74 "vlc.ecpp"
  if ( !Channel )
    reply.sout() <<  "playRecording: true," ;
  reply.out() << data[8]; // \n\t\t\t\t\t\toffset: 5\n\t\t\t\t});\n\t\t\tvlcControl.addEvent('toggle', function(id, state){\n\t\t\t\t\tvar text = null;\n\t\t\t\t\tswitch (id) {\n\t\t\t\t\tcase "TogglePlay":\n\t\t\t\t\t\ttext = state \? "
#line 81 "vlc.ecpp"
  reply.sout() << ( tr("Stop") );
  reply.out() << data[9]; // " : "
#line 81 "vlc.ecpp"
  reply.sout() << ( tr("Play") );
  reply.out() << data[10]; // ";\n\t\t\t\t\t\tbreak;\n\t\t\t\t\tcase "ToggleMute":\n\t\t\t\t\t\ttext = state \? "
#line 84 "vlc.ecpp"
  reply.sout() << ( tr("Sound on") );
  reply.out() << data[11]; // " : "
#line 84 "vlc.ecpp"
  reply.sout() << ( tr("Sound off") );
  reply.out() << data[12]; // ";\n\t\t\t\t\t\tbreak;\n\t\t\t\t\t}\n\t\t\t\t\tif (text)\n\t\t\t\t\t\t$(id).setHTML(text);\n\t\t\t\t});\n\t\t--></script>\n\t</head>\n\t<body>\n
#line 93 "vlc.ecpp"

	if (!asyncReq) {

  reply.out() << data[13]; // \t\t
  // <& pageelems.logo ...
  { 
#line 96 "vlc.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 96 "vlc.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[14]; // \n\t\t
  // <& menu ...
  { 
#line 97 "vlc.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 97 "vlc.ecpp"
    _tnt_cq4.add( "active", tnt::toString("vlc", reply.out().getloc() ) );
#line 97 "vlc.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[15]; // \n\t\t<div class="inhalt">\n
#line 99 "vlc.ecpp"

	}

#line 102 "vlc.ecpp"

	string server = request.getHost();
	server = server.substr(0, server.rfind(':'));
	string videourl;
	if (Channel != 0) {
		int streamdevPort = LiveSetup().GetStreamdevPort();
		videourl = string("http://") + server + ":" + lexical_cast<string,int>(streamdevPort) + "/" + LiveSetup().GetStreamdevType() + "/" + *Channel->GetChannelID().ToString();
	}
	else {
		videourl = string("http://") + server + ":" + lexical_cast<string,int>(LiveSetup().GetServerPort()) + "/recstream.html?recid=" + recid;
	}

  reply.out() << data[16]; // \t\t\t<embed type="application/x-vlc-plugin" pluginspage="http://www.videolan.org/" version="VideoLAN.VLCPlugin.2" id="video1" name="video1" autoplay="yes" loop="no" width="720" height="576" target="
#line 114 "vlc.ecpp"
  reply.sout() << ( videourl );
  reply.out() << data[17]; // " />\n\t\t\t
  // <& vlc.controls ...
  { 
#line 115 "vlc.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 115 "vlc.ecpp"
    _tnt_cq5.add( "asyncReq", tnt::toString((asyncReq), reply.out().getloc() ) );
#line 115 "vlc.ecpp"
    _tnt_cq5.add( "videourl", tnt::toString((videourl), reply.out().getloc() ) );
#line 115 "vlc.ecpp"
    callComp(tnt::Subcompident(std::string(), "vlc", "controls"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[18]; // \n
#line 116 "vlc.ecpp"

	if (!asyncReq) {

  reply.out() << data[19]; // \t\t</div>\n
#line 120 "vlc.ecpp"

	}

  reply.out() << data[20]; // \t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[21]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[22]; // \n
  reply.out() << data[33]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::controls_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("vlc::controls " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string videourl = tnt::stringTo<string>("videourl", "string", qparam.param("videourl"), reply.out().getloc());
bool asyncReq = tnt::stringTo<bool>("asyncReq", "bool", qparam.param("asyncReq"), reply.out().getloc());
  // </%args>

#line 20 "vlc.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 17 "vlc.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[23]; // <div id="vlcControls">\n\t<button id="TogglePlay" type="button" class="green">
#line 133 "vlc.ecpp"
  reply.sout() << ( tr("Stop") );
  reply.out() << data[24]; // </button>\n\t<button id="ToggleMute" type="button" class="red">
#line 134 "vlc.ecpp"
  reply.sout() << ( tr("Sound off") );
  reply.out() << data[25]; // </button>\n\t<button id="FullScreen" type="button" class="blue">
#line 135 "vlc.ecpp"
  reply.sout() << ( tr("Fullscreen") );
  reply.out() << data[26]; // </button>\n
#line 136 "vlc.ecpp"

	if (asyncReq) {

  reply.out() << data[27]; // \t<button id="Close" type="button" class="yellow">
#line 139 "vlc.ecpp"
  reply.sout() << ( tr("Close") );
  reply.out() << data[28]; // </button>\n
#line 140 "vlc.ecpp"

	}

  reply.out() << data[29]; // <!-- --><p>
#line 143 "vlc.ecpp"
  reply.sout() << ( tr("VLC media URL") );
  reply.out() << data[30]; // : <span class="bold"><a href="
#line 143 "vlc.ecpp"
  reply.sout() << ( videourl );
  reply.out() << data[31]; // ">
#line 143 "vlc.ecpp"
  reply.sout() << ( videourl );
  reply.out() << data[32]; // </a></span></p><!-- -->\n</div>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
